<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Include the {@link shared.make_timestamp.php} plugin
 */
require_once $smarty->_get_plugin_filepath('shared','make_timestamp');
/**
 * Smarty date_format modifier plugin
 *
 * Type:     modifier<br>
 * Name:     date_format<br>
 * Purpose:  format datestamps for russian language<br>
 * Input:<br>
 *         - string: input date string
 *         - format: strftime format for output
 *         - default_date: default date if $string is empty
 * @link http://smarty.php.net/manual/en/language.modifier.date.format.php
 *          date_format (Smarty online manual)
 * @author   Janvarev Vladislav
 * @param string
 * @param string
 * @param string
 * @return string|void
 * @uses smarty_make_timestamp()
 */
function smarty_modifier_date_format_rus($string)
{
$datef=smarty_make_timestamp($string);
//$datef=strtotime($datef);
$ned=strftime("%m",$datef);
$date=strftime("%d",$datef);
$year=strftime("%Y",$datef);
$hor=date("H:i",$datef);
$mese[0]="-";
$mese[1]="";
$mese[2]="";
$mese[3]="";
$mese[4]="";
$mese[5]="";
$mese[6]="";
$mese[7]="";
$mese[8]="";
$mese[9]="";
$mese[10]="";
$mese[11]="";
$mese[12]="";
$mesnum=(int)date("$ned");
$datef=$mese[$mesnum]." $date, $year $hor";
return $datef;
}

/* vim: set expandtab: */

?>
