<?php

/*!! Structure.Kernel.QSMini:   Quick Start.    .   :
*   *  
*   * 
*   *  
*   *     
*  {{ontolink name="System.Structure.Kernel.XcBase" text="XcBase"}}.
*/

class QSMiniKernel extends XcBase
{
/*!! Structure.Kernel.QSMini.VarDblink:  dblink     .
* @link Structure.Kernel.QSMini,Function.DB:    . */
 var $dblink;
/*!! Structure.Kernel.QSMini.VarQuerylog:
* @link Structure.Kernel.QSMini,Function.DB:    . */
 var $queryLog = array();
 var $includeLog = array();
 var $includeFor = "";
 var $_userhost = null;
 var $checkuser = 0;
 var $timer;
 var $_utfmode = false;
 var $_crossSiteName = "";

 var $skipDbError = false;
 var $lastDbError = false;
/*!! Structure.Kernel.QSMini.QSMiniKernel:
*  QSMiniKernel
* *  
* *    
* @param $config    .     wakka.config.php.
* @link Structure.Kernel.QSMini: .       .
*/
 function QSMiniKernel($config)
 {
   // multisite hack
   global $crossSiteName;
   $this->_crossSiteName = $crossSiteName;
   $this->_crossSiteDir = 'sites/'.$crossSiteName.'/';
   // from mini kernel hack
   $this->_parent = null;
   $this->_basepath = $this->srvFilePath();
   $this->service_cache["DB"] = &$this;
   $this->service_cache["Users"] = &$this;
   $this->service_cache["Access"] = &$this;

   $this->timer = $this->GetMicroTime();
   $this->config = $config;
   $this->dblink = connect($this->config["mysql_host"], $this->config["mysql_user"], $this->config["mysql_password"], $this->config["mysql_database"], $this->config["db_collation"]);
   /*
   if(!$this->dbTableExists("eventcachecheck")) {
       $this->Query("CREATE TABLE `".$this->config["table_prefix"]."eventcachecheck` (
                              `eventname` varchar(128),
                              PRIMARY KEY  (`eventname`)
                              ) ENGINE=MyISAM");
       $this->Query("CREATE TABLE `".$this->config["table_prefix"]."eventcache` (
                              `eventname` varchar(128),
                              `name` varchar(128),
                              PRIMARY KEY  (`eventname`, `name`)
                              ) ENGINE=MyISAM");
   }
   */
    $res=$this->srvLoadAll();

    //    
    $cacheFileName = 'sites/'.$this->_crossSiteName.'/cache_events/_extlib.php';
    if(!file_exists($cacheFileName)) {
       $fd = fopen($cacheFileName,'w+');
       fwrite($fd,"<?php\n");
       fwrite($fd,"  // This is an autogenerated file for add all extension library files (see classes/qsminikernel.php::QSMiniKernel)\n");
       foreach($res as $service) {
          $servname = $service["name"];

          if(is_dir('extensions/'.$servname.'/lib')) {
            $dir_pointer=opendir('extensions/'.$servname.'/lib');
            while ($res1 = readdir($dir_pointer)) {
              if(strstr($res1,'.php')) {
                //require_once('extensions/'.$servname.'/lib/'.$res1);
                fwrite($fd,"  include('".'extensions/'.$servname.'/lib/'.$res1."');\n");
              }
            }
          }

       }
       fwrite($fd,"?>");
       fclose($fd);
    }
    include($cacheFileName);
    include($this->getRootPath().'lib/SimpleXMLPHP4/usesimplexml.php');

    //   
    $cacheFileName = 'sites/'.$this->_crossSiteName.'/cache_events/_extactionpath.php';
    $cacheFileName1 = 'sites/'.$this->_crossSiteName.'/cache_events/_extaction_collection.php';
    if(!(file_exists($cacheFileName) && file_exists($cacheFileName1))) {
       $fd = fopen($cacheFileName,'w+');
       $fd1 = fopen($cacheFileName1,'w+');
       fwrite($fd,"<?php\n");
       fwrite($fd,"  // This is an autogenerated file for finding all action path (see classes/qsminikernel.php::QSMiniKernel)\n");
       fwrite($fd1,"<?php\n");
       fwrite($fd1,"  // This is an autogenerated file for finding all action with their path (see classes/qsminikernel.php::QSMiniKernel)\n");
       fwrite($fd1,'$this->_actionCollection = array('."\n");
       foreach($res as $service) {
          $servname = $service["name"];

          if(is_dir('extensions/'.$servname.'/actions')) {
             /*
             if($this->config["override_actions"]) {
                $this->config["action_path"] = 'extensions/'.$servname.'/actions'.':'.$this->config["action_path"];
             } else {
                $this->config["action_path"] .= ':'.'extensions/'.$servname.'/actions';
             }
             */
             fwrite($fd,'  $this->config["action_path"] .= ":"."extensions/'.$servname.'/actions";'."\n");
             $dir_pointer=opendir('extensions/'.$servname.'/actions');
             while ($res1 = readdir($dir_pointer)) {
               if(strstr($res1,'.php')) {
                 //require_once('extensions/'.$servname.'/lib/'.$res1);
                 $actname = str_replace('.php','',$res1);
                 fwrite($fd1,"  '".$actname."' => '".'extensions/'.$servname.'/actions'."', \n");
               }
             }
          }
       }
       if(is_dir($this->_crossSiteDir.'/actions')) {
             fwrite($fd,'  $this->config["action_path"] .= ":"."'.$this->_crossSiteDir.'/actions";'."\n");
             $dir_pointer=opendir($this->_crossSiteDir.'/actions');
             while ($res1 = readdir($dir_pointer)) {
               if(strstr($res1,'.php')) {
                 //require_once('extensions/'.$servname.'/lib/'.$res1);
                 $actname = str_replace('.php','',$res1);
                 fwrite($fd1,"  '".$actname."' => '".$this->_crossSiteDir.'/actions'."', \n");
               }
             }
          }
       $dir_pointer=opendir('actions');
       while ($res1 = readdir($dir_pointer)) {
         if(strstr($res1,'.php')) {
           $actname = str_replace('.php','',$res1);
           fwrite($fd1,"  '".$actname."' => '".'actions'."', \n");
         }
       }
       fwrite($fd1,");\n");
       fwrite($fd1,"?>");
       fwrite($fd,"?>");
       fclose($fd);
       fclose($fd1);
    }
    include($cacheFileName);
    include($cacheFileName1);

    foreach($res as $service) {
       $servname = $service["name"];

       /*   
       //   

       if(is_dir('extensions/'.$servname.'/lib')) {
         $dir_pointer=opendir('extensions/'.$servname.'/lib');
         while ($res1 = readdir($dir_pointer)) {
           if(strstr($res1,'.php')) {
             require_once('extensions/'.$servname.'/lib/'.$res1);
           }
         }
       }

       */

       /*   
       //   

       if(is_dir('extensions/'.$servname.'/actions')) {
          if($this->config["override_actions"]) {
             $this->config["action_path"] = 'extensions/'.$servname.'/actions'.':'.$this->config["action_path"];
          } else {
             $this->config["action_path"] .= ':'.'extensions/'.$servname.'/actions';
          }
       }
       */
    }

    define("QS_BASE", realpath(dirname(dirname(__FILE__))) . "/");
    $this->config["base_urlm"] = str_replace('?wakka=','', $this->config["base_url"]);
    $this->config["base_urlm"] = str_replace('wakka.php','', $this->config["base_urlm"]);
 }

 // DATABASE
/*!! Structure.Kernel.QSMini.Query:
* ##function Query($query, $debug=0)##
*       DBAL.
* @param $query 
* @param $debug      .
* @link Structure.Kernel.QSMini, Function.DB:
*       DBAL.
*/
 function Query($query, $debug=0)
 {
   if ($debug) echo "((QUERY: $query))";
   if($this->GetConfigValue("debug")>=2) $start = $this->GetMicroTime();
   $result = query($query, $this->dblink);
   if($this->GetConfigValue("debug")>=2)
   {
     $time = $this->GetMicroTime() - $start;
     $this->queryLog[] = array(
       "query"   => $query,
       "time"    => $time);
     $this->includeLog[] = array(
          "query"   => $this->includeFor.'SQL: '.substr($query,0,60).'...',
          "time"    => $time);
   }
   return $result;
 }

/*!! Structure.Kernel.QSMini.LoadSingle:
* ##function LoadSingle($query)##
*    SELECT     DBAL.   {{ontolink text="LoadAll" name="System.Structure.Kernel.QSMini.LoadAll"}}.
* @param $query 
* @return      .
* @link Structure.Kernel.QSMini, Function.DB:
*          .
*/

 function LoadSingle($query) { if ($data = $this->LoadAll($query)) return $data[0]; }

/*!! Structure.Kernel.QSMini.LoadAll:
* ##function LoadAll($query)##
*    SELECT     DBAL.
* @param $query 
* @return   .      .
* @link Structure.Kernel.QSMini, Function.DB:
*    ,    .
* @link Examples.DB:
*   (,    ):
* %%(phpplus)
     $res = $this->_db->LoadAll("SELECT * FROM ".$this->_db->config["table_prefix"]."users");
     echo '<ul>';
     foreach($res as $user) {
       echo '<li>'.$user["name"].'</li>';
     }
     echo '</ul>';
* %%
*/

 function LoadAll($query)
 {
   $data = array();
   if ($r = $this->Query($query))
   {
     while ($row = fetch_assoc($r)) $data[] = $row;
     free_result($r);
     if($this->_utfmode) {
       foreach($data as $key => $value) {
         $data[$key] = $this->dbProcessToUtf($value);
       }
     }
   }
   return $data;
 }

/*!! Structure.Kernel.QSMini.dbGetLatestId:
* ##function dbGetLatestId()##
* @link Structure.Kernel.QSMini, Function.DB:
*    ID.
*  ,     MySQL
*/
 function dbGetLatestId() {
   return mysql_insert_id($this->dblink);
 }

/*!! Structure.Kernel.QSMini.dbGetById:
* ##function dbGetById($tablename,$id)##
*  ,      ID.
* @link Structure.Kernel.QSMini, Function.DB:
*  ,     ID.
*/
 function dbGetById($tablename,$id) {
   return $this->LoadSingle("select * from ".$this->_db->config["table_prefix"].$tablename." where id='".quote($id)."'");
 }

/*!! Structure.Kernel.QSMini.dbConstructSetArray:
* ##function dbConstructSetArray($data)##
* @link Structure.Kernel.QSMini, Function.DB:
*  ,  SQL-  SET.
* @link Examples.DB:
*    {{ontolink name="System.Structure.Kernel.QSMini.insertInto"}}:
* %%(phpplus)
 function insertInto($table,$data) {
   return $this->Query('INSERT INTO '.$this->config["table_prefix"].$table.' SET '.$this->dbConstructSetArray($data));
 }
* %%
*/

 function dbConstructSetArray($data) {
   $sqlst = "";
   foreach($data as $key => $value) {
     if($this->symSome($key,'A-Za-z0-9_')) {
        $sqlst .= ", `".$key."`='".quote($value)."'";
     }
   }
   return substr($sqlst,1);
 }

/*!! Structure.Kernel.QSMini.insertInto:
* ##function insertInto($table,$data)##
* @link Structure.Kernel.QSMini, Function.DB:
*  .     **data**   **table**.
*/

 function insertInto($table,$data) {
   return $this->Query('INSERT INTO '.$this->config["table_prefix"].$table.' SET '.$this->dbConstructSetArray($data));
 }

 function dbTableExists($table) {
   global $xcKernelSkipDbError, $xcKernelLastDbError;
   $xcKernelSkipDbError = true;
   $this->Query('SHOW CREATE TABLE `'.$this->config["table_prefix"].$table.'`');
   $res = !$xcKernelLastDbError;
   $xcKernelLastDbError = false;
   $xcKernelSkipDbError = false;
   return $res;
 }

 function clearEventCache() {
   $this->Query("TRUNCATE TABLE ".$this->config["table_prefix"]."eventcachecheck");
   $this->Query("TRUNCATE TABLE ".$this->config["table_prefix"]."eventcache");
 }

/*!! Structure.Kernel.QSMini.GetMicroTime :
* ##function GetMicroTime()##
*      .    .
* @return     .
* @link Structure.Kernel.QSMini, Function.Other :
*      .    .
*/
 function GetMicroTime() { list($usec, $sec) = explode(" ",microtime()); return ((float)$usec + (float)$sec); }

/*!! Structure.Kernel.QSMini.IncludeBuffered :
* ##function IncludeBuffered($filename, $notfoundText = " ", $vars = " ", $path = " ")##
*   PHP-    .
* @param $filename  
* @param $notfoundText  ,    
* @param $vars  ,   - ,   ?
* @param $path ,   ,  .
* @link Structure.Kernel.QSMini, Function.Plugin:
*   PHP-    .
* @link Examples.Plugin:
*   Action () (  QSMini):
%%(phpplus)
 function Action($action, $params, $forceLinkTracking = 0)
 {
   $action = trim($action);
   $result = $this->IncludeBuffered(strtolower($action).".php", "<i>Unknown action \"".strip_tags($action)."\"</i>",
                                    $params, $this->config["action_path"]);
   return $result;
 }
%%
*/

 function IncludeBuffered($filename, $notfoundText = "", $vars = "", $path = "")
 {
   // debug

   if($this->GetConfigValue("debug")>=2) {
      $start = $this->GetMicroTime();
      $this->includeLog[] = array(
          "query"   => $this->includeFor.$filename,
          "time"    => '(opened)');
      $this->includeFor .= '. .';
   }

   if ($path) $dirs = explode(":", $path);
   else $dirs = array("");

   foreach($dirs as $dir)
   {
     if ($dir) $dir .= "/";
     $fullfilename = $dir.$filename;
     $fullfilename = trim($fullfilename, "./");
     if (@file_exists($fullfilename))
     {

       if (is_array($vars)) extract($vars, EXTR_SKIP);

       ob_start();
       include($fullfilename);
       $output = ob_get_contents();
       ob_end_clean();

       if($this->GetConfigValue("debug")>=2)
       {
        $this->includeFor = substr($this->includeFor,0,-3);
        $time = $this->GetMicroTime() - $start;
        $this->includeLog[] = array(
          "query"   => $this->includeFor.$filename,
          "time"    => $time);
      }

       return $output;
     }
   }
   if ($notfoundText) return $notfoundText;
   else return false;
 }

 // VARIABLES
/*!! Structure.Kernel.QSMini.GetConfigValue :
* ##GetConfigValue($name)##
*  ,   .
* @param $name  
* @link Structure.Kernel.QSMini, Function.Config:
*  ,   .
*/

 function GetConfigValue($name) { return isset( $this->config[$name] ) ? $this->config[$name] : ''; }

/*!! Structure.Kernel.QSMini.GetResourceValue :
* ##GetResourceValue($name, $lang="", $dounicode=true)##
*      .      .
* @param $name ,   .
* @link Structure.Kernel.QSMini, Function.Config:
*      .
*/

 function GetResourceValue($name, $lang="", $dounicode=true)
 {
   return $name;
 }

/*!! Structure.Kernel.QSMini.CookiesInQSMini:
* ##function SetSessionCookie($name, $value)##
* ##function SetPersistentCookie($name, $value, $remember = 1)##
* ##function DeleteCookie($name)##
* ##function GetCookie($name)##
* @link Structure.Kernel.QSMini, Function.Other.Cookie:
*     COOKIES.
*/

 // COOKIES
 function SetSessionCookie($name, $value) { SetCookie($this->config["cookie_prefix"].$name, $value, 0, "/"); $_COOKIE[$this->config["cookie_prefix"].$name] = $value; }
 function SetPersistentCookie($name, $value, $remember = 1) { SetCookie($this->config["cookie_prefix"].$name, $value, time() + ($remember ? 90*24*60*60 : 60 * 60), "/"); $_COOKIE[$this->config["cookie_prefix"].$name] = $value; }
 function DeleteCookie($name) { SetCookie($this->config["cookie_prefix"].$name, "", 1, "/"); $_COOKIE[$this->config["cookie_prefix"].$name] = ""; }
 function GetCookie($name) { return $_COOKIE[$this->config["cookie_prefix"].$name]; }

 // HTTP/REQUEST/LINK RELATED
 function SetMessage($message) { $_SESSION["message"] = $message; }
 function GetMessage() { $message = $_SESSION["message"]; $_SESSION["message"] = ""; return $message; }
 function Redirect($url) { header("Location: $url"); exit; }

 // returns just PageName[/method].
 function MiniHref($method = "", $tag = "", $addpage = "")
 {
  if (!$tag = trim($tag)) $tag = $this->tag;
  if (!$addpage) $tag=$this->SlimUrl($tag);
  //$tag = $this->Translit($tag, 0);
  $tag = trim( $tag, "/." );
  return $tag.($method ? "/".$method : "");
 }

 // returns the full url to a page/method.
 function Href($method = "", $tag = "", $params = "", $addpage=0)
 {
  //$href = $this->config["base_url"].'page/'.$this->MiniHref($method, $tag, $addpage);
  $href = $this->config["base_url"].$this->handler.'/'.$this->MiniHref($method, $tag, $addpage);
  if ($addpage) $params="add=1".($params?"&amp;".$params:"");
  if ($params)
  {
   $href .= ($this->config["rewrite_mode"] ? "?" : "&amp;").$params;
  }
  return $href;
 }

 function SlimUrl($text)
 {
  return $text;
 }

 function UseClass($class_name, $class_dir="", $file_name="" )
 {
   if(!class_exists($class_name))
   {
     if ($file_name == "") $file_name=$class_name;
     if ($class_dir == "") $class_dir=$this->classes_dir;
     $class_file = $class_dir.$file_name.".php";
     $class_file = trim($class_file, "./");

     if (!@is_readable($class_file))
      die("Cannot load class ".$class_name."  from ". $class_file. " (".$class_dir.")");
     else require_once($class_file);
   }
 }

 // FORMS
/*!! Structure.Kernel.QSMini.FormOpen, Function.WikiPages:
* ##function FormOpen($method = " ", $tag = " ", $formMethod = "post", $formname=" ", $formMore=" ")##
*     .
* @param $method 
* @param $tag 
* @param $formMethod   (POST  GET)
* @param $formname  
* @param $formMore    
* @return    .
*/

 function FormOpen($method = "", $tag = "", $formMethod = "post", $formname="", $formMore="")
 {
   $add = isset( $_REQUEST["add"] ) ? $_REQUEST["add"] : '';
   $result = "<form action=\"".$this->href($method, $tag, "", $add)."\" ".$formMore." method=\"".$formMethod."\" ".($formname?"name=\"".$formname."\" ":"").">\n";
   if (!$this->config["rewrite_mode"]) $result .= "<input type=\"hidden\" name=\"wakka\" value=\"".$this->MiniHref($method, $tag, $add)."\" />\n";
   return $result;
 }

/*!! Structure.Kernel.QSMini.FormClose, Function.WikiPages:
* ##function FormClose()##
*    .
*/

 function FormClose()
 {
   return "</form>\n";
 }

 // PLUGINS
/*!! Structure.Kernel.QSMini.QSMiniAction, Function.Plugin, Function.WikiPages:
* ##function Action($action, $params, $forceLinkTracking = 0)##
*    .
* @param $action  
* @param $params  .
*/
 function Action($action, $params, $forceLinkTracking = 0)
 {
   $action = trim($action);

   // ---multiWACKO
   $curdir = getcwd();
   //chdir($this->GetConfigValue('common_path'));
   // ---end multiWACKO
   $result = $this->IncludeBuffered(strtolower($action).".php", "<i>Unknown action \"".strip_tags($action)."\"</i>", $params, $this->config["action_path"]);
   // multiWACKO
   //chdir($curdir);
   // ---end multiWACKO

   return $result;
 }

/*!! Structure.Kernel.QSMini.QSMiniMethod, Function.Plugin, Function.WikiPages:
* ##function Method($handler,$method)##
*    .
* @param $action  
* @param $params  .
*/

 function Method($handler,$method)
 {
   //if ($method=="show") $this->CacheLinks();
   //if (!$handler = $this->page["handler"]) $handler = "page";
   $methodLocation = $handler."/".$method.".php";

   // ---multiWACKO
   $curdir = getcwd();
   //chdir($this->GetConfigValue('common_path'));
   // ---end multiWACKO

   $text = $this->IncludeBuffered($methodLocation, "<i>Unknown method \"".strip_tags($methodLocation)."\"</i>", "", $this->config["handler_path"]);

   // multiWACKO
   //chdir($curdir);
   // ---end multiWACKO
   return $text;
 }

 // USERS

/*!! Structure.Kernel.QSMini.LoadUser, Function.User:
* ##function LoadUser($name, $password = 0)##
*   ,   .
* @param $name  
* @param $password    (., )
*/


 function LoadUser($name, $password = 0)
 {
   $user = $this->LoadSingle("select * from ".$this->config["table_prefix"]."users where name = '".
           quote($name)."' ".($password === 0 ? "" : "and password = '".quote($password)."'")." limit 1");
   //if ($user) $user["options"] = $this->DecomposeOptions($user["more"]);
   return $user;
 }

/*!! Structure.Kernel.QSMini.GetUsername, Function.User:
* ##function GetUserName()##
*    (  IP-  ).
*/

 function GetUserName()
 {
   if ($user = $this->GetUser()) $name = $user["name"];
   else if ($this->_userhost) $name = $this->_userhost;
   else
   {
    if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') $name = $_SERVER["REMOTE_ADDR"];
    else if (!$name = $this->_gethostbyaddr($_SERVER["REMOTE_ADDR"])) $name = $_SERVER["REMOTE_ADDR"];
    $this->_userhost = $name;
   }
   return $name;
 }

 /*
 * @ignore
 */
 function _gethostbyaddr($ip) {if ($this->GetConfigValue("allow_gethostbyaddr")) return gethostbyaddr($ip); else return false;}

/*!! Structure.Kernel.QSMini.GetUser, Function.User, Function.Access:
* ##function GetUser()##
*  ,   .
*/

 function GetUser()
 {
   if ($_SESSION[$this->config["cookie_prefix"]."user"]) {
     $usr = $_SESSION[$this->config["cookie_prefix"]."user"];
     if($this->checkuser == 0) {
         if($this->LoadUser($usr["name"],$usr["password"])) {
            $this->checkuser = 1;
         } else {
            $this->LogoutUser();
            return null;
         }
     }
     return $_SESSION[$this->config["cookie_prefix"]."user"];
   }
   else
     return null;
 }

/*!! Structure.Kernel.QSMini.SetUser, Function.User:
* ##function SetUser($user, $setcookie=1)##
*     .
* @param $user   ().
*/

 function SetUser($user, $setcookie=1)
 {
  $_SESSION[$this->config["cookie_prefix"]."user"] = $user;
  if ($setcookie) $this->SetPersistentCookie("name", $user["name"], 1);
 }

/*!! Structure.Kernel.QSMini.LogUserIn, Function.User:
* ##function LogUserIn($user)##
*  .
* @param $user   ().
*/

 function LogUserIn($user)
 {
  $this->SetPersistentCookie("name", $user["name"], 1);
  $this->SetPersistentCookie("password", $user["password"]);
 }

/*!! Structure.Kernel.QSMini.LogoutUser, Function.User:
* ##function LogoutUser()##
*  .
*/
 function LogoutUser() { $_SESSION[$this->config["cookie_prefix"]."user"] = ""; $this->DeleteCookie("name"); $this->DeleteCookie("password"); }


 // ACCESS CONTROL
/*!! Structure.Kernel.QSMini.IsAdmin, Function.Access:
* ##function IsAdmin()##
*  true,    - .
*/

 function IsAdmin()
 {
  if (is_array($this->config['aliases']))
  {
   $al = $this->config['aliases'];
   $adm = explode("\n", $al['Admins']);
   if (in_array($this->GetUserName(),$adm))
    return true;
  }
  return false;
 }


 //aliases stuff
/**
* @ignore
*/
 function ReplaceAliases ($acl)
 {
   if (!is_array($this->config['aliases'])) return $acl;

   foreach ($this->config['aliases'] as $key => $val) $aliases[strtolower($key)]=$val;

   do
   {
     $list = array();
     $replaced = 0;
     $lines = explode("\n", $acl);
     foreach ($lines as $line)
     {
       $linel = $line;
       // check for inversion character "!"
       if (preg_match("/^\!(.*)$/", $line, $matches))
       {
         $negate = 1;
         $linel = $matches[1];
       }
       else
         $negate = 0;

       $linel = strtolower(trim($linel));

       if (isset( $aliases[$linel] ))
       {
         foreach (explode("\n", $aliases[$linel]) as $item)
         {
           $item = trim($item);
           $list[] = ($negate) ? "!".$item : $item;
         }
         $replaced++;
       }
       else
         $list[] = $line;
     }
     $acl = join("\n", $list);
   } while ($replaced > 0);
   return $acl;
 }

/*!! Structure.Kernel.QSMini.CheckACL, Function.Access:
* ##function CheckACL($user, $acl_list, $copy_to_this_acl = false, $debug=0)##
*   .
* @param $user  .
* @param $acl_list ACL
* @return TRUE,     ACL.
*/

 function CheckACL($user, $acl_list, $copy_to_this_acl = false, $debug=0)
 {
  if (is_array($user)) $user = $user["name"];
  $user = strtolower($user);

  // replace groups
  $acl = str_replace(" ", "", strtolower($this->ReplaceAliases($acl_list)));
  if ($copy_to_this_acl) $this->_acl['list'] = $acl;
  $acls = "\n".$acl."\n";

  if ($user=="guest@wacko" || $user=="")
  {
   if (($pos=strpos($acls, '*'))===false) return false;
   if ($acls{$pos-1}!="!") return true;
   return false;
  }

  $upos =strpos($acls, "\n".$user."\n");
  $aupos=strpos($acls, "\n!".$user."\n");
  $spos =strpos($acls, '*');
  $bpos =strpos($acls, '$');
  $bpos2=strpos($acls, ''); //deprecate it!!

  if ($aupos!==false) return false;

  if ($upos!==false)  return true;

  if ($spos!==false)
   if ($acls{$spos-1}=="!") return false;

  if ($bpos!==false)
   if ($acls{$bpos-1}=="!") return false;

  if ($bpos2!==false)
   if ($acls{$bpos2-1}=="!") return false;

  if ($spos!==false) return true;
  if ($bpos!==false) if ($user=="guest@wacko" || $user=="") return false;
  else return true;
  if ($bpos2!==false) if ($user=="guest@wacko" || $user=="") return false;
  else return true;

  return false;
 }

/*!! Structure.Kernel.QSMini.QSMiniRun, Function.WikiPages:
*  .  .
* @param $handler  .
* @param $tag 
* @param $method .
*/
 function Run($handler, $tag, $method = "")
 {
   $this->handler = $handler;
   $this->tag = $tag;
   $this->method = $method;

   print($this->Method($handler,$this->method));
 }

/*!! Structure.Kernel.QSMini.GRV, Function.Config:
*   GetResourceValue.
*/

   function GRV($text) {
     // an shortcut to GetResourceValue
     return $this->GetResourceValue($text);
   }

//--------------------------------- Services -------------------------------

/*!! Structure.Kernel.QSMini.srvLoadAll, Function.Extension:
* ##function srvLoadAll()##
*         .    ,   
*      .       .
*             .
*/

  function srvLoadAll() {
    if ($this->ext_services=="") {
      $res=$this->LoadAll("SELECT * FROM ".$this->config["table_prefix"]."services");
      $res1 = array();
      $allowed = explode(',',$this->config["allowed_extensions"]);

      // prefiltering
      foreach($res as $service) {
        if($this->srvIsAllowed($service["name"])) {
           $res1[] = $service;
        }
      }
      $this->ext_services = $res1;
    }
    return $this->ext_services;
  }

/*!! Structure.Kernel.QSMini.srvIsAllowed:
*  true,        .   **allowed_extensions**    **common.php**.
* @link Structure.Kernel.QSMini, Function.Multisite, Function.Extension:
*  true,        .
*/

  function srvIsAllowed($servicename) {
    if(!$this->config["array_allowed_exts"]) {
      $this->config["array_allowed_exts"] = explode(',',$this->config["allowed_extensions"]);
    }

    //return (file_exists('extensions/'.$servicename.'/common.php')) or (array_search($servicename,$this->config["array_allowed_exts"])!==false);
    return ($this->config["allowed_extensions"]=="all") || (array_search($servicename,$this->config["array_allowed_exts"])!==false);
  }

/*!! Structure.Kernel.QSMini.srvForceLoadAll, Function.Extension:
*      .   .
* .  LoadAll.
*/

  function srvForceLoadAll() {
    $this->ext_services=$this->LoadAll("SELECT * FROM ".$this->config["table_prefix"]."services");
    return $this->ext_services;
  }

/*!! Structure.Kernel.QSMini.srvIsInstalled, Function.Extension:
*  ,    .        
*     .
* @param $name  
* @return boolean true,     ; false   .
*/

  function srvIsInstalled($name) {
    $res = $this->srvLoadAll();
    if($res!="") {
      foreach($res as $serv) {
        if($serv["name"]==$name) return true;
      }
    }
    return false;
  }

/*!! Structure.Kernel.QSMini.IsServiceInstalled:
*   srvIsInstalled.
* !!  .!!
*/
  function IsServiceInstalled($name) {
    return $this->srvIsInstalled($name);
  }

// new services
/*!! Structure.Kernel.QSMini.srvRunFile, Function.Extension:
*      .       ,
*     ( extensions)   run.
* @param $servname  
* @param $filename  
* @return boolean true/false,    ,   
*/
   function srvRunFile($servname,$filename) {
       if(file_exists('extensions/'.$servname.'/run/'.$filename.'.php')) {
          include('extensions/'.$servname.'/run/'.$filename.'.php');
          return true;
       } else {
          return false;
       }
   }
/*
   function srvFactory($servname) {
       if (require_once QS_BASE.'extensions/' . $servname . '/baseclass.php') {
            $classname = 'Service_'.$servname;
            return new $classname($this);
        } else {
            throw new Exception ('Service '.$servname.' class not found');
        }
   }
*/

/*!! Structure.Kernel.QSMini.srvAllRunFile, Function.Extension:
*       .       ,
*     ( extensions)   run.
* R2.0       classes/cache_events.          .
* @param $filename  
*/
   function srvAllRunFile($filename) {
    $res=$this->srvLoadAll();
//    if(!file_exists('classes/cache_events/'.$filename.'.php')) {
//       $fd = fopen('classes/cache_events/'.$filename.'.php','w+');
    $cacheFileName = 'sites/'.$this->_crossSiteName.'/cache_events/'.$filename.'.php';
    if(!file_exists($cacheFileName)) {
       $fd = fopen($cacheFileName,'w+');
       fwrite($fd,"<?php\n");
       fwrite($fd,"  // This is an autogenerated file for event processing (see classes/qsminikernel.php::srvAllRunFile\n");
       foreach($res as $service) {
          $servname = $service["name"];
          if(file_exists('extensions/'.$servname.'/run/'.$filename.'.php')) {
             fwrite($fd,"  include('".'extensions/'.$servname.'/run/'.$filename.'.php'."');\n");
          }
       }
       fwrite($fd,"?>");
       fclose($fd);
    }
    include($cacheFileName);
   }

/*!! Structure.Kernel.QSMini.IsService, Function.Extension:
*   srvIsInstalled.
* @deprecated
*/

   function IsService($serv) {
     // an shortcut to IsServiceInstalled
     return $this->srvIsInstalled($serv);
   }

/*!! Structure.Kernel.QSMini.srvRunFileContent, Function.Extension:
*       .       ,
*     ( extensions)   run.
* @param $servname  
* @param $filename  
* @return boolean true/false,    ,   
*/

   function srvRunFileContent($servname,$filename) {
     ob_start();
     $this->srvRunFile($servname,$filename);
     $output = ob_get_contents();
     ob_end_clean();
     return $output;
   }

/*!! Structure.Kernel.QSMini.srvClearCacheEvents, Function.Extension:
*    .
*/

   function srvClearCacheEvents() {
     $this->utilClearFolder('sites/'.$this->_crossSiteName.'/cache_events','.php');

   }

/*!! Structure.Kernel.QSMini.utilClearFolder, Function.Other:
* ##function utilClearFolder($docpath,$findstr)##
*    ,    $findstr.
* @param string   
* @param string ,   
*/

   function utilClearFolder($docpath,$findstr) {
       $dir_pointer=opendir($docpath);
       while ($res1 = readdir($dir_pointer)) {
       if(strstr($res1,$findstr)) {
            unlink($docpath.'/'.$res1);
       }
       }
    }

/*
* @ignore
*/
    function dbSetUtfMode($mode) {
      $this->_utfmode = $mode;
    }
/*
* @ignore
*/
    function dbProcessToUtf($data) {
      foreach($data as $key => $value) {
        $data[$key] = $this->CP1251toUTF8($value);
      }
      return $data;
    }
/*
* @ignore
*/
   function CP1251toUTF8($str){ // (C) SiMM, $table from http://ru.wikipedia.org/wiki/CP1251
  static $table = array("\xA8" => "\xD0\x81", // 
                        "\xB8" => "\xD1\x91", // 
                        //  
                        "\xA1" => "\xD0\x8E", //  ()
                        "\xA2" => "\xD1\x9E", //  ()
                        "\xAA" => "\xD0\x84", //  ()
                        "\xAF" => "\xD0\x87", //  (I..)
                        "\xB2" => "\xD0\x86", // I (I)
                        "\xB3" => "\xD1\x96", // i (i)
                        "\xBA" => "\xD1\x94", //  ()
                        "\xBF" => "\xD1\x97", //  (i..)
                        //  
                        "\x8C" => "\xD3\x90", // &#1232; (A)
                        "\x8D" => "\xD3\x96", // &#1238; (E)
                        "\x8E" => "\xD2\xAA", // &#1194; ()
                        "\x8F" => "\xD3\xB2", // &#1266; ()
                        "\x9C" => "\xD3\x91", // &#1233; ()
                        "\x9D" => "\xD3\x97", // &#1239; ()
                        "\x9E" => "\xD2\xAB", // &#1195; ()
                        "\x9F" => "\xD3\xB3", // &#1267; ()
                       );
  return preg_replace('#[\x80-\xFF]#se',
                      ' "$0" >= "\xF0" ? "\xD1".chr(ord("$0")-0x70) :
                       ("$0" >= "\xC0" ? "\xD0".chr(ord("$0")-0x30) :
                        (isset($table["$0"]) ? $table["$0"] : "")
                       )',
                      $str
                     );
}

   // input data checks
/*!! Structure.Kernel.QSMini.symAlnum:
* ##function symAlnum($str)##
*     .
*  True,          /   .
* @link Structure.Kernel.QSMini, Function.DataCheck:
*     .
*  True,          /   .
*/
   function symAlnum($str) {
      return $this->symSome($str,'A-Za-z0-9');
   }

/*!! Structure.Kernel.QSMini.symSome:
* ##function symSome($str,$symbols)##
*     .
*  True,      ,    ( ).
*  :  -  ,      (: A-Za-z)
* @link Structure.Kernel.QSMini, Function.DataCheck:
*     .
*  True,      ,    ( ).
*/
   function symSome($str,$symbols) {
      return ereg('^['.$symbols.']+$',$str);
   }

/*!! Structure.Kernel.QSMini.symPageTag, Function.DataCheck:
* ##function symPageTag($str)##
*     .
*  True,      ,      WW.
* @param string  
* @return boolean  True,      ,      WW.
*/
   function symPageTag($str) {
      $res = preg_match("/^(".$this->language["ALPHANUM"]."+)$/", $str) && (stripos($str, '_') === false);
      return $res;
   }

   //some AMF functions

/*!! Structure.Kernel.QSMini.amfResultOk, Function.Xmini:
* ##function amfResultOk($data)##
*     Xmini 1.1      .
*/
   function amfResultOk($data) {
      $result = array();
      $result["status"] = "ok";
      $result["data"] = $data;
      return $result;
   }
/*!! Structure.Kernel.QSMini.amfResultError, Function.Xmini:
* ##function amfResultError($data)##
*     Xmini 1.1      .
*/
   function amfResultError($data) {
      $result = array();
      $result["status"] = "error";
      $result["data"] = $data;
      return $result;
   }

/*!! Structure.Kernel.QSMini.amfResultOkSessionCache, Function.Xmini, Version.QS.v3s3:
* ##function amfResultOkSessionCache($data,$cachestring)##
*      ,   ,    . Cachestring -   .
*        .
*/
   function amfResultOkSessionCache($data,$cachestring) {
      $result = array();
      $result["status"] = "oksesscache";
      $result["cachestring"] = "req".$cachestring;
      $result["data"] = $data;
      return $result;
   }

/*!! Structure.Kernel.QSMini.amfResultOkGlobalCache, Function.Xmini, Version.QS.v4s0:
* ##function amfResultOkGlobalCache($data,$cachestring,$cachetime)##
*      ,   ,    . Cachestring -   . Cachetime -   ,   .
*        .
*/
   function amfResultOkGlobalCache($data,$cachestring,$cachetime) {
      $result = array();
      $result["status"] = "okglobalcache";
      $result["cachestring"] = "req".$cachestring;
      $result["cachetime"] = $cachetime;
      $result["data"] = $data;
      return $result;
   }

/*!! Structure.Kernel.QSMini.xmSWFHandlerCachePath, Function.Xmini, Version.QS.v3s3:
* ##function xmSWFHandlerCachePath($file)##
*       /.       ,    .
*/
   function xmSWFHandlerCachePath($file) {
      return $this->config["base_urlm"].str_replace('.swf','.version'.filemtime($this->getRootPath().$file).'.swf',$file);
   }

   function utilHTTPCacheFile($file) {
      return $this->config["base_urlm"].$file.'.version'.filemtime($this->getRootPath().$file);
   }

/*!! Structure.Kernel.QSMini.getRootPath, Version.QS.v3s3:
* ##function getRootPath()##
*   .      .
*/
   function getRootPath() {
     if(file_exists("./wakka.php")) {
       return "./";
     }
     if(file_exists("../../wakka.php")) {
       return "../../";
     }
     if(file_exists("../wakka.php")) {
       return "../";
     }
     return null;
   }

   function getSiteDataPath() {
     global $crossSiteName;
     return $this->getRootPath()."sites/".$crossSiteName."/";
   }

   function getHTTPSiteDataPath() {
     global $crossSiteName;
     return $this->config["base_urlm"]."sites/".$crossSiteName."/";
   }

}

?>
